diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/block-ack-manager.cc ns-3.34/src/wifi/model/block-ack-manager.cc
--- ns-3.33/src/wifi/model/block-ack-manager.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/block-ack-manager.cc	2021-07-14 10:31:07.000000000 -0700
@@ -25,7 +25,6 @@
 #include "ctrl-headers.h"
 #include "mgt-headers.h"
 #include "wifi-mac-queue.h"
-#include "mac-tx-middle.h"
 #include "qos-utils.h"
 #include "wifi-tx-vector.h"
 
@@ -124,7 +123,7 @@
   agreement.SetBufferSize (reqHdr->GetBufferSize());
   agreement.SetTimeout (reqHdr->GetTimeout ());
   agreement.SetAmsduSupport (reqHdr->IsAmsduSupported ());
-  agreement.SetHtSupported (m_stationManager->GetHtSupported ());
+  agreement.SetHtSupported (m_stationManager->GetHtSupported () && m_stationManager->GetHtSupported (recipient));
   if (reqHdr->IsImmediateBlockAck ())
     {
       agreement.SetImmediateBlockAck ();
@@ -183,9 +182,10 @@
 }
 
 void
-BlockAckManager::UpdateAgreement (const MgtAddBaResponseHeader *respHdr, Mac48Address recipient)
+BlockAckManager::UpdateAgreement (const MgtAddBaResponseHeader *respHdr, Mac48Address recipient,
+                                  uint16_t startingSeq)
 {
-  NS_LOG_FUNCTION (this << respHdr << recipient);
+  NS_LOG_FUNCTION (this << respHdr << recipient << startingSeq);
   uint8_t tid = respHdr->GetTid ();
   AgreementsI it = m_agreements.find (std::make_pair (recipient, tid));
   if (it != m_agreements.end ())
@@ -194,22 +194,7 @@
       agreement.SetBufferSize (respHdr->GetBufferSize () + 1);
       agreement.SetTimeout (respHdr->GetTimeout ());
       agreement.SetAmsduSupport (respHdr->IsAmsduSupported ());
-      // When the Add BA Response is received, there may be a packet transmitted
-      // under the normal ack policy that needs to be retransmitted. If so, such
-      // packet is placed in the retransmit queue. If this is the case, the starting
-      // sequence number is the sequence number of such packet. Otherwise, it is
-      // the sequence number that will be assigned to the next packet to be transmitted.
-      uint16_t startSeq;
-      WifiMacQueue::ConstIterator mpduIt = m_retryPackets->PeekByTidAndAddress (tid, recipient);
-      if (mpduIt != m_retryPackets->end ())
-        {
-          startSeq = (*mpduIt)->GetHeader ().GetSequenceNumber ();
-        }
-      else
-        {
-          startSeq = m_txMiddle->GetNextSeqNumberByTidAndAddress (tid, recipient);
-        }
-      agreement.SetStartingSequence (startSeq);
+      agreement.SetStartingSequence (startingSeq);
       agreement.InitTxWindow ();
       if (respHdr->IsImmediateBlockAck ())
         {
@@ -288,7 +273,7 @@
 }
 
 Ptr<const WifiMacQueueItem>
-BlockAckManager::GetBar (bool remove)
+BlockAckManager::GetBar (bool remove, uint8_t tid, Mac48Address address)
 {
   Ptr<const WifiMacQueueItem> bar;
   // remove all expired MPDUs in the retransmission queue, so that Block Ack Requests
@@ -299,9 +284,18 @@
 
   while (nextBar != m_bars.end ())
     {
+      Mac48Address recipient = nextBar->bar->GetHeader ().GetAddr1 ();
+
+      if (address != Mac48Address::GetBroadcast () && tid != 8
+            && (!nextBar->bar->GetHeader ().IsBlockAckReq ()
+                  || address != recipient || tid != nextBar->tid))
+        {
+          // we can only return a BAR addressed to the given station and for the given TID
+          nextBar++;
+          continue;
+        }
       if (nextBar->bar->GetHeader ().IsBlockAckReq ())
         {
-          Mac48Address recipient = nextBar->bar->GetHeader ().GetAddr1 ();
           AgreementsI it = m_agreements.find (std::make_pair (recipient, nextBar->tid));
           if (it == m_agreements.end ())
             {
@@ -461,17 +455,26 @@
 }
 
 void
-BlockAckManager::NotifyGotBlockAck (const CtrlBAckResponseHeader *blockAck, Mac48Address recipient, double rxSnr, double dataSnr, WifiTxVector dataTxVector)
-{
-  NS_LOG_FUNCTION (this << blockAck << recipient << rxSnr << dataSnr << dataTxVector);
-  if (!blockAck->IsMultiTid ())
-    {
-      uint8_t tid = blockAck->GetTidInfo ();
+BlockAckManager::NotifyGotBlockAck (const CtrlBAckResponseHeader& blockAck, Mac48Address recipient,
+                                    const std::set<uint8_t>& tids, double rxSnr, double dataSnr,
+                                    const WifiTxVector& dataTxVector, size_t index)
+{
+  NS_LOG_FUNCTION (this << blockAck << recipient << rxSnr << dataSnr << dataTxVector << index);
+  if (!blockAck.IsMultiTid ())
+    {
+      uint8_t tid = blockAck.GetTidInfo (index);
+      // If this is a Multi-STA Block Ack with All-ack context (TID equal to 14),
+      // use the TID passed by the caller.
+      if (tid == 14)
+        {
+          NS_ASSERT (blockAck.GetAckType (index) && tids.size () == 1);
+          tid = *tids.begin ();
+        }
       if (ExistsAgreementInState (recipient, tid, OriginatorBlockAckAgreement::ESTABLISHED))
         {
           bool foundFirstLost = false;
-          uint8_t nSuccessfulMpdus = 0;
-          uint8_t nFailedMpdus = 0;
+          uint16_t nSuccessfulMpdus = 0;
+          uint16_t nFailedMpdus = 0;
           AgreementsI it = m_agreements.find (std::make_pair (recipient, tid));
           PacketQueueI queueEnd = it->second.second.end ();
 
@@ -491,12 +494,12 @@
           uint16_t currentStartingSeq = it->second.first.GetStartingSequence ();
           uint16_t currentSeq = SEQNO_SPACE_SIZE;   // invalid value
 
-          if (blockAck->IsBasic ())
+          if (blockAck.IsBasic ())
             {
               for (PacketQueueI queueIt = it->second.second.begin (); queueIt != queueEnd; )
                 {
                   currentSeq = (*queueIt)->GetHeader ().GetSequenceNumber ();
-                  if (blockAck->IsFragmentReceived (currentSeq,
+                  if (blockAck.IsFragmentReceived (currentSeq,
                                                     (*queueIt)->GetHeader ().GetFragmentNumber ()))
                     {
                       nSuccessfulMpdus++;
@@ -520,18 +523,18 @@
                   RemoveOldPackets (recipient, tid, (currentSeq + 1) % SEQNO_SPACE_SIZE);
                 }
             }
-          else if (blockAck->IsCompressed () || blockAck->IsExtendedCompressed ())
+          else if (blockAck.IsCompressed () || blockAck.IsExtendedCompressed () || blockAck.IsMultiSta ())
             {
               for (PacketQueueI queueIt = it->second.second.begin (); queueIt != queueEnd; )
                 {
                   currentSeq = (*queueIt)->GetHeader ().GetSequenceNumber ();
-                  if (blockAck->IsPacketReceived (currentSeq))
+                  if (blockAck.IsPacketReceived (currentSeq, index))
                     {
                       it->second.first.NotifyAckedMpdu (*queueIt);
                       nSuccessfulMpdus++;
                       if (!m_txOkCallback.IsNull ())
                         {
-                          m_txOkCallback ((*queueIt)->GetHeader ());
+                          m_txOkCallback (*queueIt);
                         }
                     }
                   else if (!QosUtilsIsOldPacket (currentStartingSeq, currentSeq))
@@ -539,7 +542,7 @@
                       nFailedMpdus++;
                       if (!m_txFailedCallback.IsNull ())
                         {
-                          m_txFailedCallback ((*queueIt)->GetHeader ());
+                          m_txFailedCallback (*queueIt);
                         }
                       InsertInRetryQueue (*queueIt);
                     }
@@ -599,13 +602,6 @@
 }
 
 void
-BlockAckManager::SetBlockAckType (BlockAckType bAckType)
-{
-  NS_LOG_FUNCTION (this << bAckType);
-  m_blockAckType = bAckType;
-}
-
-void
 BlockAckManager::NotifyDiscardedMpdu (Ptr<const WifiMacQueueItem> mpdu)
 {
   NS_LOG_FUNCTION (this << *mpdu);
@@ -664,7 +660,7 @@
   NS_ASSERT (it != m_agreements.end ());
 
   CtrlBAckRequestHeader reqHdr;
-  reqHdr.SetType (m_blockAckType);
+  reqHdr.SetType ((*it).second.first.GetBlockAckReqType ());
   reqHdr.SetTidInfo (tid);
   reqHdr.SetStartingSequence ((*it).second.first.GetStartingSequence ());
   return reqHdr;
@@ -674,21 +670,38 @@
 BlockAckManager::ScheduleBar (Ptr<const WifiMacQueueItem> bar, bool skipIfNoDataQueued)
 {
   NS_LOG_FUNCTION (this << *bar);
-  NS_ASSERT (bar->GetHeader ().IsBlockAckReq ());
+  NS_ASSERT (bar->GetHeader ().IsBlockAckReq () || bar->GetHeader ().IsTrigger ());
 
-  CtrlBAckRequestHeader reqHdr;
-  bar->GetPacket ()->PeekHeader (reqHdr);
-  uint8_t tid = reqHdr.GetTidInfo ();
+  uint8_t tid = 0;
+  if (bar->GetHeader ().IsBlockAckReq ())
+    {
+      CtrlBAckRequestHeader reqHdr;
+      bar->GetPacket ()->PeekHeader (reqHdr);
+      tid = reqHdr.GetTidInfo ();
+    }
+#ifdef NS3_BUILD_PROFILE_DEBUG
+  else
+    {
+      CtrlTriggerHeader triggerHdr;
+      bar->GetPacket ()->PeekHeader (triggerHdr);
+      NS_ASSERT (triggerHdr.IsMuBar ());
+    }
+#endif
   Bar request (bar, tid, skipIfNoDataQueued);
 
   // if a BAR for the given agreement is present, replace it with the new one
-  for (std::list<Bar>::const_iterator i = m_bars.begin (); i != m_bars.end (); i++)
+  std::list<Bar>::const_iterator i = m_bars.end ();
+
+  if (bar->GetHeader ().IsBlockAckReq ())
     {
-      if (i->bar->GetHeader ().GetAddr1 () == bar->GetHeader ().GetAddr1 () && i->tid == tid)
+      for (i = m_bars.begin (); i != m_bars.end (); i++)
         {
-          i = m_bars.erase (i);
-          m_bars.insert (i, request);
-          return;
+          if (i->bar->GetHeader ().IsBlockAckReq ()
+              && i->bar->GetHeader ().GetAddr1 () == bar->GetHeader ().GetAddr1 () && i->tid == tid)
+            {
+              i = m_bars.erase (i);
+              break;
+            }
         }
     }
 
@@ -698,7 +711,7 @@
     }
   else
     {
-      m_bars.push_back (request);
+      m_bars.insert (i, request);
     }
 }
 
@@ -906,13 +919,6 @@
 }
 
 void
-BlockAckManager::SetTxMiddle (const Ptr<MacTxMiddle> txMiddle)
-{
-  NS_LOG_FUNCTION (this << txMiddle);
-  m_txMiddle = txMiddle;
-}
-
-void
 BlockAckManager::SetTxOkCallback (TxOk callback)
 {
   m_txOkCallback = callback;
@@ -980,6 +986,22 @@
   return size;
 }
 
+BlockAckReqType
+BlockAckManager::GetBlockAckReqType (Mac48Address recipient, uint8_t tid) const
+{
+  AgreementsCI it = m_agreements.find (std::make_pair (recipient, tid));
+  NS_ABORT_MSG_IF (it == m_agreements.end (), "No established Block Ack agreement");
+  return it->second.first.GetBlockAckReqType ();
+}
+
+BlockAckType
+BlockAckManager::GetBlockAckType (Mac48Address recipient, uint8_t tid) const
+{
+  AgreementsCI it = m_agreements.find (std::make_pair (recipient, tid));
+  NS_ABORT_MSG_IF (it == m_agreements.end (), "No established Block Ack agreement");
+  return it->second.first.GetBlockAckType ();
+}
+
 uint16_t
 BlockAckManager::GetOriginatorStartingSequence (Mac48Address recipient, uint8_t tid) const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/block-ack-manager.h ns-3.34/src/wifi/model/block-ack-manager.h
--- ns-3.33/src/wifi/model/block-ack-manager.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/block-ack-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -28,6 +28,7 @@
 #include "originator-block-ack-agreement.h"
 #include "block-ack-type.h"
 #include "wifi-mac-queue-item.h"
+#include "wifi-tx-vector.h"
 
 namespace ns3 {
 
@@ -36,7 +37,6 @@
 class MgtAddBaRequestHeader;
 class CtrlBAckResponseHeader;
 class CtrlBAckRequestHeader;
-class MacTxMiddle;
 class WifiMacQueue;
 class WifiMode;
 class Packet;
@@ -50,16 +50,16 @@
 {
   Bar ();
   /**
-   * Store a BlockAckRequest along with the corresponding TID.
+   * Store a BlockAckRequest along with the corresponding TID or a MU-BAR Trigger Frame.
    *
    * \param bar the BAR
    * \param tid the Traffic ID
    * \param skipIfNoDataQueued true to hold this BAR if there is no data queued
    */
   Bar (Ptr<const WifiMacQueueItem> bar, uint8_t tid, bool skipIfNoDataQueued = false);
-  Ptr<const WifiMacQueueItem> bar;  ///< BlockAckRequest
-  uint8_t tid;                      ///< TID
-  bool skipIfNoDataQueued;          ///< do not send if there is no data queued
+  Ptr<const WifiMacQueueItem> bar;  ///< BlockAckRequest or MU-BAR Trigger Frame
+  uint8_t tid;                      ///< TID (unused if MU-BAR)
+  bool skipIfNoDataQueued;          ///< do not send if there is no data queued (unused if MU-BAR)
 };
 
 
@@ -137,10 +137,12 @@
   /**
    * \param respHdr Relative Add block ack response (action frame).
    * \param recipient Address of peer station involved in block ack mechanism.
+   * \param startingSeq the updated starting sequence number
    *
    * Invoked upon receipt of a ADDBA response frame from <i>recipient</i>.
    */
-  void UpdateAgreement (const MgtAddBaResponseHeader *respHdr, Mac48Address recipient);
+  void UpdateAgreement (const MgtAddBaResponseHeader *respHdr, Mac48Address recipient,
+                        uint16_t startingSeq);
   /**
    * \param mpdu MPDU to store.
    *
@@ -149,13 +151,19 @@
    */
   void StorePacket (Ptr<WifiMacQueueItem> mpdu);
   /**
-   * Returns the next BlockAckRequest to send, if any.
+   * Returns the next BlockAckRequest or MU-BAR Trigger Frame to send, if any.
+   * If the given recipient is not the broadcast address and the given TID is less
+   * than 8, then only return a BlockAckRequest, if any, addressed to that recipient
+   * and for the given TID.
    *
    * \param remove true if the BAR has to be removed from the queue
+   * \param tid the TID
+   * \param recipient the recipient of the BAR
    *
    * \return the next BAR to be sent, if any
    */
-  Ptr<const WifiMacQueueItem> GetBar (bool remove = true);
+  Ptr<const WifiMacQueueItem> GetBar (bool remove = true, uint8_t tid = 8,
+                                      Mac48Address recipient = Mac48Address::GetBroadcast ());
   /**
    * Returns true if there are packets that need of retransmission or at least a
    * BAR is scheduled. Returns false otherwise.
@@ -185,17 +193,23 @@
   /**
    * \param blockAck The received BlockAck frame.
    * \param recipient Sender of BlockAck frame.
+   * \param tids the set of TIDs the acknowledged MPDUs belong to
    * \param rxSnr received SNR of the BlockAck frame itself
    * \param dataSnr data SNR reported by remote station
    * \param dataTxVector the TXVECTOR used to send the Data
+   * \param index the index of the Per AID TID Info subfield, in case of Multi-STA
+   *              Block Ack, or 0, otherwise
    *
    * Invoked upon receipt of a BlockAck frame. Typically, this function, is called
    * by ns3::QosTxop object. Performs a check on which MPDUs, previously sent
    * with Ack Policy set to Block Ack, were correctly received by the recipient.
    * An acknowledged MPDU is removed from the buffer, retransmitted otherwise.
+   * Note that <i>tids</i> is only used if <i>blockAck</i> is a Multi-STA Block Ack
+   * using All-ack context.
    */
-  void NotifyGotBlockAck (const CtrlBAckResponseHeader *blockAck, Mac48Address recipient,
-                          double rxSnr, double dataSnr, WifiTxVector dataTxVector);
+  void NotifyGotBlockAck (const CtrlBAckResponseHeader& blockAck, Mac48Address recipient,
+                          const std::set<uint8_t>& tids, double rxSnr, double dataSnr,
+                          const WifiTxVector& dataTxVector, size_t index = 0);
   /**
    * \param recipient Sender of the expected BlockAck frame.
    * \param tid Traffic ID.
@@ -276,22 +290,10 @@
    * \param queue The WifiMacQueue object.
    */
   void SetQueue (const Ptr<WifiMacQueue> queue);
-  /**
-   * Set the MacTxMiddle
-   * \param txMiddle the MacTxMiddle
-   */
-  void SetTxMiddle (const Ptr<MacTxMiddle> txMiddle);
 
   /**
-   * \param bAckType Type of BlockAck
-   *
-   * See ctrl-headers.h for more details.
-   */
-  void SetBlockAckType (BlockAckType bAckType);
-
-  /**
-   * Set BlockAck inactivity callback
-   * \param callback the BlockAck inactivity callback function
+   * Set block ack inactivity callback
+   * \param callback the block ack inactivity callback function
    */
   void SetBlockAckInactivityCallback (Callback<void, Mac48Address, uint8_t, bool> callback);
   /**
@@ -340,6 +342,24 @@
    */
   uint16_t GetRecipientBufferSize (Mac48Address recipient, uint8_t tid) const;
   /**
+   * This function returns the type of Block Acks sent to the recipient.
+   *
+   * \param recipient MAC address of recipient
+   * \param tid Traffic ID
+   *
+   * \returns the type of Block Acks sent to the recipient
+   */
+  BlockAckReqType GetBlockAckReqType (Mac48Address recipient, uint8_t tid) const;
+  /**
+   * This function returns the type of Block Acks sent by the recipient.
+   *
+   * \param recipient MAC address
+   * \param tid Traffic ID
+   *
+   * \returns the type of Block Acks sent by the recipient
+   */
+  BlockAckType GetBlockAckType (Mac48Address recipient, uint8_t tid) const;
+  /**
    * This function returns the starting sequence number of the transmit window.
    *
    * \param tid Traffic ID
@@ -350,15 +370,13 @@
   uint16_t GetOriginatorStartingSequence (Mac48Address recipient, uint8_t tid) const;
 
   /**
-   * typedef for a callback to invoke when a
-   * packet transmission was completed successfully.
+   * typedef for a callback to invoke when an MPDU is successfully ack'ed.
    */
-  typedef Callback <void, const WifiMacHeader&> TxOk;
+  typedef Callback <void, Ptr<const WifiMacQueueItem>> TxOk;
   /**
-   * typedef for a callback to invoke when a
-   * packet transmission was failed.
+   * typedef for a callback to invoke when an MPDU is negatively ack'ed.
    */
-  typedef Callback <void, const WifiMacHeader&> TxFailed;
+  typedef Callback <void, Ptr<const WifiMacQueueItem>> TxFailed;
   /**
    * \param callback the callback to invoke when a
    * packet transmission was completed successfully.
@@ -395,6 +413,7 @@
   /**
    * \param recipient the recipient
    * \param tid the TID
+   * \return the BlockAckRequest header for the established BA agreement
    *
    * Get the BlockAckRequest header for the established BA agreement
    * (<i>recipient</i>,<i>tid</i>).
@@ -506,9 +525,6 @@
   std::list<Bar> m_bars; ///< list of BARs
 
   uint8_t m_blockAckThreshold; ///< block ack threshold
-  BlockAckType m_blockAckType; ///< BlockAck type
-  Ptr<MacTxMiddle> m_txMiddle; ///< the MacTxMiddle
-  Mac48Address m_address;      ///< address
   Ptr<WifiMacQueue> m_queue;   ///< queue
   Callback<void, Mac48Address, uint8_t, bool> m_blockAckInactivityTimeout; ///< BlockAck inactivity timeout callback
   Callback<void, Mac48Address, uint8_t> m_blockPackets;   ///< block packets callback
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/block-ack-type.cc ns-3.34/src/wifi/model/block-ack-type.cc
--- ns-3.33/src/wifi/model/block-ack-type.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/block-ack-type.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,134 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 Universita' di Napoli
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "block-ack-type.h"
+#include "ns3/fatal-error.h"
+
+namespace ns3 {
+
+BlockAckType::BlockAckType (Variant v)
+  : m_variant (v)
+{
+  switch (m_variant)
+    {
+    case BASIC:
+      m_bitmapLen.push_back (128);
+      break;
+    case COMPRESSED:
+    case EXTENDED_COMPRESSED:
+      m_bitmapLen.push_back (8);
+      break;
+    case MULTI_TID:
+    case MULTI_STA:
+      // m_bitmapLen is left empty.
+      break;
+    default:
+      NS_FATAL_ERROR ("Unknown block ack type");
+    }
+}
+
+BlockAckType::BlockAckType ()
+  : BlockAckType (BASIC)
+{
+}
+
+BlockAckType::BlockAckType (Variant v, std::vector<uint8_t> l)
+  : m_variant (v),
+    m_bitmapLen (l)
+{
+}
+
+BlockAckReqType::BlockAckReqType (Variant v)
+  : m_variant (v)
+{
+  switch (m_variant)
+    {
+    case BASIC:
+    case COMPRESSED:
+    case EXTENDED_COMPRESSED:
+      m_nSeqControls = 1;
+      break;
+    case MULTI_TID:
+      m_nSeqControls = 0;
+      break;
+    default:
+      NS_FATAL_ERROR ("Unknown block ack request type");
+    }
+}
+
+BlockAckReqType::BlockAckReqType ()
+  : BlockAckReqType (BASIC)
+{
+}
+
+BlockAckReqType::BlockAckReqType (Variant v, uint8_t nSeqControls)
+  : m_variant (v),
+    m_nSeqControls (nSeqControls)
+{
+}
+
+std::ostream &operator << (std::ostream &os, const BlockAckType &type)
+{
+  switch (type.m_variant)
+    {
+    case BlockAckType::BASIC:
+      os << "basic-block-ack";
+      break;
+    case BlockAckType::COMPRESSED:
+      os << "compressed-block-ack";
+      break;
+    case BlockAckType::EXTENDED_COMPRESSED:
+      os << "extended-compressed-block-ack";
+      break;
+    case BlockAckType::MULTI_TID:
+      os << "multi-tid-block-ack[" << type.m_bitmapLen.size () << "]";
+      break;
+    case BlockAckType::MULTI_STA:
+      os << "multi-sta-block-ack[" << type.m_bitmapLen.size () << "]";
+      break;
+    default:
+      NS_FATAL_ERROR ("Unknown block ack type");
+    }
+  return os;
+}
+
+std::ostream &operator << (std::ostream &os, const BlockAckReqType &type)
+{
+  switch (type.m_variant)
+    {
+    case BlockAckReqType::BASIC:
+      os << "basic-block-ack-req";
+      break;
+    case BlockAckReqType::COMPRESSED:
+      os << "compressed-block-ack-req";
+      break;
+    case BlockAckReqType::EXTENDED_COMPRESSED:
+      os << "extended-compressed-block-ack-req";
+      break;
+    case BlockAckReqType::MULTI_TID:
+      os << "multi-tid-block-ack-req[" << type.m_nSeqControls << "]";
+      break;
+    default:
+      NS_FATAL_ERROR ("Unknown block ack request type");
+    }
+  return os;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/block-ack-type.h ns-3.34/src/wifi/model/block-ack-type.h
--- ns-3.33/src/wifi/model/block-ack-type.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/block-ack-type.h	2021-07-14 10:31:07.000000000 -0700
@@ -21,20 +21,111 @@
 #ifndef BLOCK_ACK_TYPE_H
 #define BLOCK_ACK_TYPE_H
 
+#include <ostream>
+#include <vector>
+
 namespace ns3 {
 
 /**
  * \ingroup wifi
- * The different block ack policies.
+ * The different BlockAck variants.
  */
-enum BlockAckType
+struct BlockAckType
 {
-  BASIC_BLOCK_ACK,
-  COMPRESSED_BLOCK_ACK,
-  EXTENDED_COMPRESSED_BLOCK_ACK,
-  MULTI_TID_BLOCK_ACK,
+  /**
+   * \enum Variant
+   * \brief The BlockAck variants
+   */
+  enum Variant
+  {
+    BASIC,
+    COMPRESSED,
+    EXTENDED_COMPRESSED,
+    MULTI_TID,
+    MULTI_STA
+  };
+  enum Variant m_variant;           //!< Block Ack variant
+  std::vector<uint8_t> m_bitmapLen; //!< Length (bytes) of included bitmaps
+
+  /**
+   * Default constructor for BlockAckType.
+   */
+  BlockAckType ();
+  /**
+   * Constructor for BlockAckType with given variant.
+   *
+   * \param v the Block Ack variant
+   */
+  BlockAckType (Variant v);
+  /**
+   * Constructor for BlockAckType with given variant
+   * and bitmap length.
+   *
+   * \param v the Block Ack variant
+   * \param l the length (bytes) of included bitmaps
+   */
+  BlockAckType (Variant v, std::vector<uint8_t> l);
 };
 
+/**
+ * \ingroup wifi
+ * The different BlockAckRequest variants.
+ */
+struct BlockAckReqType
+{
+  /**
+   * \enum Variant
+   * \brief The BlockAckReq variants
+   */
+  enum Variant
+  {
+    BASIC,
+    COMPRESSED,
+    EXTENDED_COMPRESSED,
+    MULTI_TID
+  };
+  enum Variant m_variant;           //!< Block Ack Request variant
+  uint8_t m_nSeqControls;           //!< Number of included Starting Sequence Control fields.
+                                    //!< This member is added for future support of Multi-TID BARs
+
+  /**
+   * Default constructor for BlockAckReqType.
+   */
+  BlockAckReqType ();
+  /**
+   * Constructor for BlockAckReqType with given variant.
+   *
+   * \param v the Block Ack Request variant
+   */
+  BlockAckReqType (Variant v);
+  /**
+   * Constructor for BlockAckReqType with given variant
+   * and number of SSC fields.
+   *
+   * \param v the Block Ack Request variant
+   * \param nSeqControls the number of included Starting Sequence Control fields
+   */
+  BlockAckReqType (Variant v, uint8_t nSeqControls);
+};
+
+/**
+ * Serialize BlockAckType to ostream in a human-readable form.
+ *
+ * \param os std::ostream
+ * \param type block ack type
+ * \return std::ostream
+ */
+std::ostream &operator << (std::ostream &os, const BlockAckType &type);
+
+/**
+ * Serialize BlockAckReqType to ostream in a human-readable form.
+ *
+ * \param os std::ostream
+ * \param type block ack request type
+ * \return std::ostream
+ */
+std::ostream &operator << (std::ostream &os, const BlockAckReqType &type);
+
 } //namespace ns3
 
 #endif /* BLOCK_ACK_TYPE_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/block-ack-window.cc ns-3.34/src/wifi/model/block-ack-window.cc
--- ns-3.33/src/wifi/model/block-ack-window.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/block-ack-window.cc	2021-07-14 10:31:07.000000000 -0700
@@ -73,6 +73,14 @@
   return m_window.at ((m_head + distance) % m_window.size ());
 }
 
+std::vector<bool>::const_reference
+BlockAckWindow::At (std::size_t distance) const
+{
+  NS_ASSERT (distance < m_window.size ());
+
+  return m_window.at ((m_head + distance) % m_window.size ());
+}
+
 void
 BlockAckWindow::Advance (std::size_t count)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/block-ack-window.h ns-3.34/src/wifi/model/block-ack-window.h
--- ns-3.33/src/wifi/model/block-ack-window.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/block-ack-window.h	2021-07-14 10:31:07.000000000 -0700
@@ -103,6 +103,16 @@
    */
   std::vector<bool>::reference At (std::size_t distance);
   /**
+   * Get a const reference to the element in the window having the given distance from
+   * the current winStart. Note that the given distance must be less than the
+   * window size.
+   *
+   * \param distance the given distance
+   * \return a const reference to the element in the window having the given distance
+   *         from the current winStart
+   */
+  std::vector<bool>::const_reference At (std::size_t distance) const;
+  /**
    * Advance the current winStart by the given number of positions.
    *
    * \param count the number of positions the current winStart must be advanced by
